package org.siqisource.agave.orm.condition;

import java.util.ArrayList;
import java.util.List;

import org.siqisource.agave.orm.expression.OrderBy;
import org.siqisource.agave.orm.expression.SqlCompareExpression;

public class Condition {

	/** expressions */
	private List<SqlCompareExpression> expressions = null;

	/** orderBy */
	private OrderBy orderBy = null;

	public Condition() {

	}

	public void addExpression(SqlCompareExpression expression) {
		if (expressions == null) {
			expressions = new ArrayList<SqlCompareExpression>();
		}
		expressions.add(expression);
	}

	public String getComboedExpressions() {
		StringBuffer sql = new StringBuffer();
		if (expressions != null) {
			if (expressions.size() > 0) {
				for (int i = 0, iSize = expressions.size(); i < iSize; i++) {
					SqlCompareExpression expression = expressions.get(i);
					sql.append(expression.getExpression(i));
				}
			}
		}

		return sql.toString();
	}

	public Condition copy() {
		Condition conditionList = new Condition();
		conditionList.orderBy = this.orderBy.copy();
		conditionList.expressions = new ArrayList<SqlCompareExpression>();
		for (SqlCompareExpression expression : this.expressions) {
			conditionList.expressions.add(expression);// fleet copy
		}
		return conditionList;
	}

	public void orderAsc(String propertiesNames) {
		if (this.orderBy == null) {
			this.orderBy = new OrderBy();
		}
		orderBy.orderAsc(propertiesNames);
	}

	public void orderDesc(String propertiesNames) {
		if (this.orderBy == null) {
			this.orderBy = new OrderBy();
		}
		orderBy.orderDesc(propertiesNames);
	}

	public void order(String propertiesNames, String direction) {
		if (OrderBy.ASC.trim().equalsIgnoreCase(direction)) {
			this.orderAsc(propertiesNames);
		} else if (OrderBy.DESC.trim().equalsIgnoreCase(direction)) {
			this.orderDesc(propertiesNames);
		}
	}

	public OrderBy getOrderBy() {
		return orderBy;
	}

	public List<SqlCompareExpression> getExpressions() {
		return expressions;
	}
}
