package org.siqisource.agave.orm.expression;

import java.util.ArrayList;
import java.util.List;

import org.siqisource.agave.utils.NameConverter;

public class OrderBy {

	public static String ASC = " ASC ";

	public static String DESC = " DESC ";

	private List<String[]> orders = new ArrayList<String[]>(2);

	public void orderAsc(String propertyNames) {
		order(propertyNames, ASC);
	}

	public void orderDesc(String propertyNames) {
		order(propertyNames, DESC);
	}

	@Override
	public String toString() {
		StringBuffer sbSql = new StringBuffer(64);
		sbSql.append(" ORDER BY ");
		for (int i = 0; i < orders.size(); i++) {
			String[] order = orders.get(i);
			if (i != 0) {
				sbSql.append(" , ");
			}

			sbSql.append(order[0]);
			sbSql.append(" ");
			sbSql.append(order[1]);
		}
		return sbSql.toString();
	}

	private void order(String propertyNames, String direction) {
		String[] propertyNameArray = propertyNames.split(",");
		for (String property : propertyNameArray) {
			String[] order = { NameConverter.propertyToColumnWithTableAlias(property), direction };
			orders.add(order);
		}
	}

	public OrderBy copy() {
		OrderBy orderBy = new OrderBy();
		for (String[] order : orders) {
			orderBy.orders.add(order);
		}
		return orderBy;
	}

}
